function cost = costFun(x,sm,mbc,info)
if info.inputScaling; x=x.*info.inputScale; end

% get current set of LTI matrices from x
F=[zeros(info.nx/2) eye(info.nx/2) zeros(info.nx/2,info.nu);
   reshape(x,info.nx/2+info.ny,info.nx+info.nu)]; % F=[A B; C D]

switch info.coststr
    case 'inf'
        % convert LTI to LTV
        tmp=zeros(size(F));
        for k=1:info.npsi % direct implementation of Eq43 from the paper 
             tmp(:,:,k)=mbc.Ms1(:,:,k)*F*mbc.Ms2(:,:,k)+mbc.Ms3(:,:,k);
        end
        e=abs(tmp-sm); % find peak err in each element
        e=max(e,[],3); % peak err across all rotor angles
        cost=sum(e(:));
    case 'frobenius'
        % convert LTI to LTV
        e=zeros(size(F));
        for k=1:info.npsi
            tmp=sm(:,:,k)-(mbc.Ms1(:,:,k)*F*mbc.Ms2(:,:,k)+mbc.Ms3(:,:,k));
            e=e+norm(tmp,'fro');
        end
        cost=sum(e(:));
end

if info.outputScaling; cost=cost/info.outputScale; end
% keyboard